VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form MainForm 
   Caption         =   "Ap pdf2image sdk demo!"
   ClientHeight    =   2205
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5565
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2205
   ScaleWidth      =   5565
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnDemo3 
      Caption         =   "demo3"
      Height          =   375
      Left            =   3480
      TabIndex        =   3
      Top             =   600
      Width           =   1095
   End
   Begin VB.CommandButton btnDemo2 
      Caption         =   "demo2"
      Height          =   375
      Left            =   2040
      TabIndex        =   2
      Top             =   600
      Width           =   1095
   End
   Begin ComctlLib.ProgressBar m_ProgressBar 
      Align           =   2  'Align Bottom
      Height          =   420
      Left            =   0
      TabIndex        =   1
      Top             =   1785
      Width           =   5565
      _ExtentX        =   9816
      _ExtentY        =   741
      _Version        =   327682
      Appearance      =   1
   End
   Begin VB.CommandButton btnDemo1 
      Caption         =   "demo1"
      Default         =   -1  'True
      Height          =   375
      Index           =   0
      Left            =   480
      TabIndex        =   0
      Top             =   600
      Width           =   1095
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'1.1 SDK interface definitions.
Private Declare Function apOpen Lib "pdf2image.dll" (ByVal lpFileName As String, ByVal lpOwnerPw As String, ByVal lpUserPw As String) As Long
Private Declare Function apClose Lib "pdf2image.dll" (ByVal nHandle As Long) As Long
Private Declare Function apConvert Lib "pdf2image.dll" (ByVal nHandle As Long) As Long
Private Declare Function apConvertPage Lib "pdf2image.dll" (ByVal nHandle As Long, ByVal nPageNo As Long) As Long
Private Declare Function apConvertPageToStream Lib "pdf2image.dll" (ByVal nHandle As Long, ByVal nPageNo As Long, ByRef pImageStream As Long, ByRef nSize As Long) As Long
Private Declare Function apSetProperty Lib "pdf2image.dll" (ByVal nHandle As Long, ByVal nIndex As Long, ByVal lpValue As String, ByVal nValue As Long, ByVal nOther As Long) As Long
Private Declare Function apGetProperty Lib "pdf2image.dll" (ByVal nHandle As Long, ByVal nIndex As Long, ByRef lpValue As String, ByRef nValue As Long) As Long


'1.2 Definitions of converter's properties
'==========================================================================================
'read/write properties
 Const AP_PROP_OUTDIR = 1         'Destination directory.
 Const AP_PROP_PREFIX = 2         'The prefix of the name of result image file.
 Const AP_PROP_PAGEZOOM = 3       'Zoom scale of the source pdf page.
 Const AP_PROP_BGCOLOR = 4        'Image background color.
 Const AP_PROP_IMAGETYPE = 5      'Result image format.
 Const AP_PROP_BITCOUNT = 6       'Color bits per pixel.
 Const AP_PROP_XDPI = 7           'Horizontal resolution.
 Const AP_PROP_YDPI = 8           'Vertical resolution.
 Const AP_PROP_QUALITY = 9        'JPEG compression quality.
 Const AP_PROP_COMPRESSION = 10   'TIFF compression mode.
 Const AP_PROP_MULTIPAGES = 11    'Multipages TIFF file.
 Const AP_PROP_GRAYSCALE = 12     'Grayscale image.
 Const AP_PROP_XDIMENSIONS = 13   'The width of the result image in pixel
 Const AP_PROP_YDIMENSIONS = 14   'The height of the result image in pixel
 Const AP_PROP_ROTATEANGLE = 15   'Rotate angle of result image
    
'read only properties
 Const AP_PROP_PAGECOUNT = 20     'The total pages of source pdf file.
 Const AP_PROP_PAGEHEIGHT = 21    'Height of the current page of source pdf file.
 Const AP_PROP_PAGEWIDTH = 22     'Width of the current page of source pdf file.
'==========================================================================================

'1.3 TIFF tag's definitions.
'==========================================================================================
 Const AP_TIFF_COMPRESSION_NONE = 0      'No compression.
 Const AP_TIFF_COMPRESSION_LZW = 1       '1,4,8,24bits(default 4,8,24bits)
 Const AP_TIFF_COMPRESSION_JPEG = 2      'Grayscale 8bits,24bits
 Const AP_TIFF_COMPRESSION_PACKBITS = 3  '4,8,24bits
 Const AP_TIFF_COMPRESSION_CCITTG4 = 4   '1bit(default 1bit)
 Const AP_TIFF_COMPRESSION_CCITTG3 = 5   '1bit
 Const AP_TIFF_COMPRESSION_RLE = 6       '1bit
'==========================================================================================


'1.4 Image type's definitions
'=======================================================================================
 Const AP_IMAGE_BMP = 1    'BMP
 Const AP_IMAGE_EMF = 2    'EMF
 Const AP_IMAGE_WMF = 3    'WMF
 Const AP_IMAGE_JPG = 4    'JPG
 Const AP_IMAGE_PNG = 5    'PNG
 Const AP_IMAGE_GIF = 6    'GIF
 Const AP_IMAGE_TIF = 7    'TIF
 Const AP_IMAGE_PCX = 8    'PCX

 Const AP_IMAGE_JPEG = 4   'JPEG
 Const AP_IMAGE_TIFF = 7   'TIFF
'=======================================================================================

'1.5 Return code's definitions.
'==========================================================================================
 Const RTN_OK = 1           'Successful operation.
 Const ERR_UNKNOWN = -99    'Unknown system error.
       
 Const ERR_OVER_MAXTHREADS = -1     'Over the limit amount of threads
 Const ERR_FILE_UNEXIST = -2        'Source PDF file unexist.
 Const ERR_FILE_DAMAGED = -3        'Source PDF file is damaged.
 Const ERR_FILE_RESTRICTED = -4     'Source PDF file is restricted.
       
 Const ERR_INVALID_PAGE = -5      'The PDF page is invalid.
 Const ERR_CONVERT_FAILURE = -8   'Conversion failure.
 Const ERR_INVALID_STREAM = -9    'Invalid memory stream address.
 Const ERR_INVALID_HANDLE = -10   'Invalid converter's handle.
'==========================================================================================


'1.6 Windows API definitions.
'==========================================================================================
 Private Const OFS_MAXPATHNAME = 128
 
 Private Type SECURITY_ATTRIBUTES
         nLength As Long
         lpSecurityDescriptor As Long
         bInheritHandle As Long
 End Type

 Private Declare Function GetTickCount Lib "kernel32" () As Long
 Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
 Private Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
 Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)


'==========================================================================================


'Demo1 - Convert all pdf pages to bmp format file(s).
Private Sub btnDemo1_Click(Index As Integer)
   Dim nHandle As Long
   Dim iStartTick As Long, iEndTick As Long
   Dim iPageNo, iPageAmount As Long
   
   iStartTick = GetTickCount
   
   'Open pdf file and creating a converter.
   nHandle = apOpen("sample.pdf", "", "")
   Select Case nHandle
     Case ERR_OVER_MAXTHREADS
       MessageBox this, "Over the limit amount of threads,please waiting!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_UNEXIST
       MessageBox this, "Source pdf file unexist!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_DAMAGED
       MessageBox this, "Source pdf file damaged!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_RESTRICTED
       MessageBox this, "Source pdf file restricted!", "Pdf2Image Demo", MB_OK
       Exit Sub
   End Select
   
   'Setting the converter's propertys.
   'For more, please refer to above definitions.
   apSetProperty nHandle, AP_PROP_OUTDIR, "./demo1", 0, 0   'output directory
   apSetProperty nHandle, AP_PROP_PREFIX, "myimg", 0, 0     'prefix of image file name
   apSetProperty nHandle, AP_PROP_IMAGETYPE, "", AP_IMAGE_BMP, 0  'image type
   apSetProperty nHandle, AP_PROP_XDPI, "", 120, 0   'horizontal dpi
   apSetProperty nHandle, AP_PROP_YDPI, "", 120, 0   'vertical dpi
   'apSetProperty nHandle, AP_PROP_ROTATEANGLE, "", 75, 0   'Rotate angle of result image
   
   'Get the amount of the source pdf pages
   apGetProperty nHandle, AP_PROP_PAGECOUNT, "", iPageAmount
   
   'To convert the pdf file.
   For iPageNo = 1 To iPageAmount
       apConvertPage nHandle, iPageNo
       
       'Setting conversion's progress.
       m_ProgressBar.Value = Round((iPageNo * 1#) / iPageAmount * 100)
   Next
   
   'Close pdf file and destory the converter.
   apClose (nHandle)
   
   'To count conversion's time(ms).
   iEndTick = GetTickCount
   MessageBox this, "Conversion successful,it passed " + CStr(iEndTick - iStartTick) + "ms!", "Pdf2Image Demo", MB_OK
End Sub

'Demo2 - Convert appointed pdf pages to tiff format file(s).
Private Sub btnDemo2_Click()
   Dim nHandle As Long
   Dim iPageCount, iStartTick, iEndTick, iPage As Long
   
   iStartTick = GetTickCount
   
   'Open pdf file and creating a converter.
   nHandle = apOpen("sample.pdf", "", "")
   Select Case nHandle
     Case ERR_OVER_MAXTHREADS
       MessageBox this, "Over the limit amount of threads,please waiting!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_UNEXIST
       MessageBox this, "Source pdf file unexist!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_DAMAGED
       MessageBox this, "Source pdf file damaged!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_RESTRICTED
       MessageBox this, "Source pdf file restricted!", "Pdf2Image Demo", MB_OK
       Exit Sub
   End Select
   
   'Setting the converter's propertys.
   'For more, please refer to above definitions.
   apSetProperty nHandle, AP_PROP_OUTDIR, "./demo2", 0, 0   'output directory
   apSetProperty nHandle, AP_PROP_IMAGETYPE, "", AP_IMAGE_TIFF, 0  'image type
   apSetProperty nHandle, AP_PROP_BITCOUNT, "", 24, 0  'color bits
   apSetProperty nHandle, AP_PROP_XDPI, "", 120, 0   'horizontal dpi
   apSetProperty nHandle, AP_PROP_YDPI, "", 120, 0   'vertical dpi
   apSetProperty nHandle, AP_PROP_COMPRESSION, "", AP_TIFF_COMPRESSION_LZW, 0   'tiff compression mode
   'apSetProperty nHandle, AP_PROP_MULTIPAGES, "", True, 0    'vertical dpi
   
   'To convert the pdf file.
   apGetProperty nHandle, AP_PROP_PAGECOUNT, 0, iPageCount
   For iPage = 1 To iPageCount
       apConvertPage nHandle, iPage
       
       'Setting conversion's progress.
       m_ProgressBar.Value = Round((iPage * 1#) / iPageCount * 100)
   Next
   
   'Close pdf file and destory the converter.
   apClose (nHandle)
   
   'To count conversion's time(ms).
   iEndTick = GetTickCount
   MessageBox this, "Conversion successful,it passed " + CStr(iEndTick - iStartTick) + "ms!", "Pdf2Image Demo", MB_OK
End Sub


'demo3 - Convert appointed pdf pages to memory stream.
Private Sub btnDemo3_Click()
   Dim nHandle As Long
   Dim iStartTick, iEndTick, iPos As Long
   Dim m_Pages
   m_Pages = Array(1, 4, 7, 11, 20, 19, 13, 5, 6, 14, 8, 0)
   
   iStartTick = GetTickCount
   
   'Open pdf file and creating a converter.
   nHandle = apOpen("sample.pdf", "", "")
   Select Case nHandle
     Case ERR_OVER_MAXTHREADS
       MessageBox this, "Over the limit amount of threads,please waiting!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_UNEXIST
       MessageBox this, "Source pdf file unexist!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_DAMAGED
       MessageBox this, "Source pdf file damaged!", "Pdf2Image Demo", MB_OK
       Exit Sub
     Case ERR_FILE_RESTRICTED
       MessageBox this, "Source pdf file restricted!", "Pdf2Image Demo", MB_OK
       Exit Sub
   End Select
   
   'Setting the converter's propertys.
   'For more, please refer to above definitions.
   apSetProperty nHandle, AP_PROP_IMAGETYPE, "", AP_IMAGE_WMF, 0  'image type
   apSetProperty nHandle, AP_PROP_XDIMENSIONS, "", 1122, 0
   apSetProperty nHandle, AP_PROP_YDIMENSIONS, "", 1452, 0
   
   'To convert the pdf file.
   Dim attr As SECURITY_ATTRIBUTES
   Dim sImgFile As String
   Dim iPageCount, nSize As Long
   Dim pImageStream As Long
   Dim bBuffer() As Byte
   
   CreateDirectory "./demo3", attr
   iPageCount = UBound(m_Pages)
   For iPos = 0 To iPageCount - 1
       'You can save image stream to database, to file, or to others, etc.
       'The "pImageStream" is a pointer which point to memory image stream.
       apConvertPageToStream nHandle, m_Pages(iPos), pImageStream, nSize
       
       'Here,it saves the memory image stream to bytes buffer
       ReDim bBuffer(nSize) As Byte
       CopyMemory ByVal VarPtr(bBuffer(0)), ByVal pImageStream, nSize
       
       'Here,it saves the buffer to file.
       If nSize > 0 Then
          CreateDirectory "./demo3", attr
          sImgFile = "./demo3/myimg_" + CStr(m_Pages(iPos)) + ".wmf"
          
          Open sImgFile For Binary As #1
          Put #1, , bBuffer
          Close #1
       End If
       
       'Setting conversion's progress.
       m_ProgressBar.Value = Round(((iPos + 1) * 1#) / iPageCount * 100)
   Next
   
   'Close pdf file and destory the converter.
   apClose (nHandle)
   
   'To count conversion's time(ms).
   iEndTick = GetTickCount
   MessageBox this, "Conversion successful,it passed " + CStr(iEndTick - iStartTick) + "ms!", "Pdf2Image Demo", MB_OK
End Sub
